#!/usr/bin/perl
# $Id: openvz_ipv6.pl
# Copyright 2006-2017 SOLARSPEED.NET., All rights reserved.
#

use lib qw(/usr/sausalito/perl);
use CCE;
use Sauce::Util;
my $cce = new CCE;

$cce->connectuds();

(my $sys_oid) = $cce->find('System', '');
my($ok, $System) = $cce->get($sys_oid);

$filename = '/etc/vz/vz.conf';
my $ok = Sauce::Util::editfile($filename, *edit_vzcfg, $System);

$filenameMod = '/etc/modprobe.d/net-pf-10.conf';
my $ok = Sauce::Util::editfile($filenameMod, *edit_netpf, $System);

system("/bin/rm -f /etc/vz/vz.conf.backup.*");
system("/bin/rm -f /etc/modprobe.d/net-pf-10.conf.backup.*");

$cce->bye('SUCCESS');
exit(0);

sub edit_vzcfg {
    my ($in, $out, $System) = @_;
    while(<$in>) {
        if (/^IPV6=(.*)$/i) { 
            print $out 'IPV6="yes"' . "\n";
        }
        elsif (/^IP6TABLES=(.*)$/i) { 
            print $out 'IP6TABLES="ip6_tables ip6table_filter ip6table_mangle ip6t_REJECT nf_conntrack_ipv6"' . "\n";
        }
        else {
            print $out $_;
        }
    }
    return 1;
}

sub edit_netpf {
    my ($in, $out, $System) = @_;
    while(<$in>) {
        if (/^alias net-pf-10(.*)$/i) { 
            print $out 'alias net-pf-10 ipv6' . "\n";
        }
        else {
            print $out $_;
        }
    }
    system("/sbin/sysctl -p &>/dev/null || :");
    return 1;
}

# 
# Copyright (c) 2017 Michael Stauber, SOLARSPEED.NET
# All Rights Reserved.
# 
# 1. Redistributions of source code must retain the above copyright 
#    notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright 
#    notice, this list of conditions and the following disclaimer in 
#    the documentation and/or other materials provided with the 
#    distribution.
# 
# 3. Neither the name of the copyright holder nor the names of its 
#    contributors may be used to endorse or promote products derived 
#    from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
# 
# You acknowledge that this software is not designed or intended for 
# use in the design, construction, operation or maintenance of any 
# nuclear facility.
# 

